import java.util.Arrays;
import java.util.Random;

/**
   This program measures the runtime of the optimized
   merge sort algorithm on a sequence of growing arrays.
*/
public class MergeSort_Optimized_Profile
{
   public static void main(String[] args)
   {
      final int size = 1_000_000; // starting size for the arrays
      final int iterations = 20;  // how many times to increase the array size

      System.out.println("Merge sort optimized (cutoff = 64).");

      for (int i = 1; i <= iterations; ++i)
      {
         final int[] array = MergeSort.randomIntArray(i*size, 1_000_000);

         final long startTime = System.currentTimeMillis();
            MergeSort_Optimized.sort(array);
         final long stopTime = System.currentTimeMillis();
         System.out.println("For n = " + (i*size) + ", time = " + (stopTime - startTime));
      }
   }
}
